/***************************************
	Auteur : Pierre Aubert
	Mail : pierre.aubert@lapp.in2p3.fr
	Licence : CeCILL-C
****************************************/
#include <iostream>
#include <vector>
#include <numeric>
#include <execution>
#include <curand.h>

int main(void){
	size_t nbElement(100000000lu);
	std::vector<float> vecValue(nbElement);
	//Create the generator
	curandGenerator_t generator;
	curandCreateGenerator(&generator, CURAND_RNG_PSEUDO_DEFAULT);
	//Set the random seed
	curandSetPseudoRandomGeneratorSeed(generator, 42);
	//Generate a normal distribution (generator, data, size, mean, std)
	curandGenerateNormal(generator, (float*)vecValue.data(), nbElement, 2.0f, 1.0f);
	//Destroy the generator
	curandDestroyGenerator(generator);
	float res = std::reduce(std::execution::par_unseq,  vecValue.begin(), vecValue.end());
	std::cout << "mean = " << (res/((float)nbElement)) << std::endl;
	return 0;
}

